<?php

	include 'client/minifier.php';
    ob_start();

?>

<?php

    require_once 'client/bingc.lib.php';
    include 'config.php';

    global $CFG;

    $request_type = ""; // used in decide on the include page
    $page_title = $CFG->site_meta_title;
    $page_desc = $CFG->site_meta_desc;
    $page_keywords = $CFG->site_meta_keywords;
    $page_desc = $CFG->site_meta_desc;

    $content_title = '';
    $content_html = '';
    $response = '';

    $history = '';

    // add to history
    $bclient = new bingc\client();

    if (isset($_GET[$CFG->old_search_param]) && trim($_GET[$CFG->old_search_param] != '')) { // make sure there is no html or echo before 301 redirect

        debug_to_console("client - keyword is " . $_GET[$CFG->old_search_param]);
        // check if keyword is valid and also get slug to use in the url
        $response = $bclient->check_keyword($_GET[$CFG->old_search_param], $CFG->site_type, $_SERVER['HTTP_HOST']);

        //echo 'log ' . $response['data']['log'];
        debug_to_console($response['data']);

        // check if it is authorised request (query/keyword will be set)
        if(isset($response['data']['query'])) {

            if (!$response['data']['query']['keyword']['is_valid']) {

                debug_to_console('client - keyword is not valid');
                header("Location: $CFG->invalid_search_url");

            } else {

                $url = $CFG->site_search_uri . $response['data']['query']['keyword']['slug'];
                debug_to_console('client - redirect to ' . $url);
                header("HTTP/1.1 301 Moved Permanently");
                header("Location: $url");
            }
        }
        else {
                debug_to_console('client - unauthorised request');
                header("Location: $CFG->unauth_search_url");
        }
    }
    else if (isset($_GET['s'])) {  // this param is set in .htaccess file as part of url rewrite

        $request_type = 'search'; // include
        //echo '[s-condition]keyword: ' . $_GET['s']."<br>";

        $response = $bclient->get($_GET['s'], $CFG->site_type, $_SERVER['HTTP_HOST']);

        //echo $response['data']['log'];
		debug_to_console('client - logging entire response');
		debug_to_console($response);

        if (isset($response['data']['results'])) {
            debug_to_console($response['data']['results']);
        }

        // check if it is authorised request (query/keyword will be set)
        if(isset($response['data']['query'])) {

            if (!$response['data']['query']['keyword']['is_valid']) {
                debug_to_console('client - keyword is not valid');
                header("Location: $CFG->invalid_search_url");

            } else {
                $page_title = $response['data']['query']['keyword']['title_text'];

                $content_title = $response['data']['query']['keyword']['title_text'];

				// new page desc code improve seo
				$clean_piped_titles = $bclient->clean_result_titles($response, 'cp');
				$page_desc_str = 'Showing ' . count($response['data']['results']).' coloring pages related to ' . $content_title . '. ';
				$page_desc_str .= 'Some of the coloring pages shown here are ' .  str_replace('|', ', ', $clean_piped_titles) . '.';
				$page_desc = substr($page_desc_str, 0, strpos($page_desc_str, ' ', 160)) . '...';

				// this below array containing clean titles is used to populate alt and title tags of image results
				$clean_titles_a = explode('|', $clean_piped_titles);

				$page_keywords = $response['data']['query']['keyword']['clean_text'];
                $bclient->add_to_history($response['data']['query']['keyword']['title_text'].'|'.$response['data']['query']['keyword']['slug']);
            }
        }
        else {
            debug_to_console('client - unauthorised request');
            header("Location: $CFG->unauth_search_url");
        }

    }
    else if (isset($_GET['p'])) { // this param is set in .htaccess file as part of url rewrite
        $request_type = 'page'; // include content.php
        //echo 'page: ' . $_GET['p'];

        $content = file_get_contents($CFG->site_content_json);
        $cname = $_GET['p'];
        $json_a = json_decode($content, true);
        //var_dump(json_decode($content, true));
        //echo "<script> console.log('".$json_a."');</script>";
        //echo "request name: " . $cname;
        if (isset($json_a['categories'][$cname])) {
            //echo "content name: " . $json_a['categories'][$cname]['title'];
            $page_title = $json_a['categories'][$cname]['title'];
            $page_desc = $json_a['categories'][$cname]['title'];
            $page_keywords = $json_a['categories'][$cname]['title'];

            $content_title = $json_a['categories'][$cname]['title'];
            $content_html = $json_a['categories'][$cname]['html'];
        }
        else {
            echo "<script> console.log('client - content data not found');</script>";
            debug_to_console('client - unauthorised request');
            header("Location: $CFG->unauth_search_url");

        }
    }
    else {
        $request_type = '';
    }

	// this code is for getting geo info (country) for a given client ip (used for displaying sb ads)
	// IMPORTANT - this code does not return data for local IP (local testing)
	$geo_info = $bclient->get_geoip_info($_SERVER['REMOTE_ADDR'], $CFG->site_type, $_SERVER['HTTP_HOST']);

	// for testing
	//$geo_info = $bclient->get_geoip_info('43.224.158.176', 'cp', $_SERVER['HTTP_HOST']);

	//echo $geo_info['data']['log'];
	//debug_to_console($geo_info['data']);

?>


<!DOCTYPE html>
<html lang="en">
	<head>
		<title><?php echo $page_title.' - '. $CFG->site_meta_title_suffix; ?></title>
        <base href="<?php echo $CFG->site_url; ?>" />
        <meta http-equiv="content-type" content="text/html; charset=utf-8" />
		<meta name="viewport" content="width=device-width, initial-scale=1">
        <meta name="keywords" content="<?php echo $page_keywords; ?>" />
        <meta name="author" content="PCP" />
        <meta name="description" content="<?php echo $page_desc; ?>" />
        <link href="favicon.ico" rel="shortcut icon" type="image/vnd.microsoft.icon" />

		<meta charset="utf-8">
		<meta name = "format-detection" content = "telephone=no" />

		<link rel="icon" href="favicon.ico">
		<link rel="shortcut icon" href="favicon.ico" />

		<link rel="stylesheet" href="/css/owl.carousel.css">
		<link rel="stylesheet" href="css/pandalocker.2.1.0.min.css">

		<?php //<link rel="stylesheet" href="/css/slider.css"> ?>

		<link rel="stylesheet" href="/css/style.css">

		<script src="/js/jquery.js"></script>
		<script src="/js/jquery-migrate-1.1.1.js"></script>
		<script src="/js/script.js"></script>
		<script src="/js/jquery.ui.totop.js"></script>
		<script src="/js/superfish.js"></script>
		<script src="/js/jquery.equalheights.js"></script>
		<script src="/js/jquery.mobilemenu.js"></script>
		<script src="/js/jquery.easing.1.3.js"></script>
		<script src="/js/owl.carousel.js"></script>
		<?php /*
		<script src="/js/jquery.flexslider-min.js"></script>
		<script src="/js/kwiks.js"></script>
		*/ ?>


		<script>
			$(document).ready(function(){
				$().UItoTop({ easingType: 'easeOutQuart' });
				var owl = $("#owl");
				owl.owlCarousel({
					items : 4, //10 items above 1000px browser width
					itemsDesktop : [995,3], //5 items between 1000px and 901px
					itemsDesktopSmall : [767, 2], // betweem 900px and 601px
					itemsTablet: [700, 2], //2 items between 600 and 0
					itemsMobile : [479, 1], // itemsMobile disabled - inherit from itemsTablet option
					navigation : true,
				});
			})
			<?php /*
			var Main = Main || {};
			jQuery(window).load(function() {
				window.responsiveFlag = jQuery('#responsiveFlag').css('display');
				Main.gallery = new Gallery();
				jQuery(window).resize(function() {
					Main.gallery.update();
				});
			});

			function Gallery(){
				var self = this,
					container = jQuery('.flexslider'),
					clone = container.clone( false );
					this.init = function (){
						if( responsiveFlag == 'block' ){
						var slides = container.find('.slides');
						slides.kwicks({
							max : 500,
							spacing : 0
						}).find('li > a').click(function (){
							return false;
						});
						} else {
							container.flexslider();
						}
					}
					this.update = function () {
						var currentState = jQuery('#responsiveFlag').css('display');
						if(responsiveFlag != currentState) {
							responsiveFlag = currentState;
							container.replaceWith(clone);
							container = clone;
							clone = container.clone( false );
							this.init();
						}
					}
				this.init();
			}
			*/ ?>
		</script>

		<?php /*
		<script type="text/javascript" src="js/pandalocker.2.1.0.min.js"></script>

		<script>
			jQuery(document).ready(function ($) {
				$('.to-lock').sociallocker({
					theme: 'dandyish',
					overlap:{
						mode: 'blurring',
						intensity: '5'
					},
					buttons:{
						order: ["facebook-like","google-plus"],
						counters: true,
						lazy: false
					},
					facebook: { like: { url: "https://printablecoloringpages.in" } },
					google: { plus: { url: "https://printablecoloringpages.in" } },
					url: 'https://printablecoloringpages.in',
					text: 'Like us on facebook or google plus to access coloring pages..thank you.<br/>*In case you don\'t see coloring pages after like, please refresh the page.<br/>'
				});
			});
		</script>
		*/ ?>

		<!--[if lt IE 8]>
		<div style=' clear: both; text-align:center; position: relative;'>
			<a href="https://windows.microsoft.com/en-US/internet-explorer/products/ie/home?ocid=ie6_countdown_bannercode">
				<img src="https://storage.ie6countdown.com/assets/100/images/banners/warning_bar_0000_us.jpg" border="0" height="42" width="820" alt="You are using an outdated browser. For a faster, safer browsing experience, upgrade for free today." />
			</a>
		</div>
		<![endif]-->
		<!--[if lt IE 9]>
		<script src="js/html5shiv.js"></script>
		<link rel="stylesheet" media="screen" href="css/ie.css">
		<![endif]-->

        <?php echo $CFG->g_analytics_script; ?>
        <?php echo $CFG->g_page_ad_script; ?>

	</head>
	<body class="page1" id="top">

<!--==============================header=================================-->
		<header>
			<div class="clear"></div>
			<div class="hmain">
				<div class="container_12"   style="background-color: white;">
					<div class="grid_3">
						<a href="/">
							<img src="logo.png" alt="<?php echo $CFG->site_name ?>" style="height: 80px">
						</a>
					</div>
					<div class="grid_9">
						<div class="menu_block">
							<nav class="horizontal-nav full-width horizontalNav-notprocessed">
								<ul class="sf-menu">
									<li><a href="/alphabet-coloring-pages" title="Alphabet Coloring Pages">Alphabet</a></li>
									<li><a href="/animals-coloring-pages" title="Animals Coloring Pages">Animals</a></li>
									<li><a href="/birthday-coloring-pages" title="Birthday Coloring Pages">Birthday</a></li>
									<li><a href="/boys-coloring-pages" title="Boys Coloring Pages">Boys</a></li>
									<li><a href="/buildings-coloring-pages" title="Buildings Coloring Pages">Buildings</a></li>
									<li><a href="/cartoons-coloring-pages" title="Cartoons Coloring Pages">Cartoons</a></li>
									<li><a href="/christmas-coloring-pages" title="Christmas Coloring Pages">Christmas</a></li>
									<li><a href="/country-flag-coloring-pages" title="Country Flag Coloring Pages">Country Flag</a></li>
									<li><a href="/country-map-coloring-pages" title="Country Map Coloring Pages">Country Map</a></li>
									<li><a href="/disney-coloring-pages" title="Disney Coloring Pages">Disney</a></li>
									<li><a href="/fantasy-coloring-pages" title="Fantasy Coloring Pages">Fantasy</a></li>
									<li><a href="/food-coloring-pages" title="Food Coloring Pages">Food</a></li>
									<li><a href="/girls-coloring-pages" title="Girls Coloring Pages">Girls</a></li>
									<li><a href="/holidays-coloring-pages" title="Holidays Coloring Pages">Holidays</a></li>
									<li><a href="/music-coloring-pages" title="Music Coloring Pages">Music</a></li>
									<li><a href="/nature-coloring-pages" title="Nature Coloring Pages">Nature</a></li>
									<li><a href="/new-year-coloring-pages" title="New Year Coloring Pages">New Year</a></li>
									<li><a href="/people-coloring-pages" title="People Coloring Pages">People</a></li>
									<li><a href="/religious-coloring-pages" title="Religious Coloring Pages">Religious</a></li>
									<li><a href="/sports-coloring-pages" title="Sports Coloring Pages">Sports</a></li>
									<li><a href="/toys-coloring-pages" title="Toys Coloring Pages">Toys</a></li>
									<li><a href="/transportation-coloring-pages" title="Transportation Coloring Pages">Transportation</a></li>
									<li><a href="/us-sports-coloring-pages" title="US Sports Team Coloring Pages">US Sports Team</a></li>
									<li><a href="/valentine-day-coloring-pages" title="Valentine Day Coloring Pages">Valentine Day</a></li>
								</ul>
							</nav>
						</div>
						<div class="clear"></div>
					</div>
				</div>
				<div class="container_12">
					<div class="grid_12" style="text-align: center;">
						<?php echo $CFG->g_ad_top_banner; ?>
					</div>
					<div class="grid_12">
						<div id="search-form">
							<form class="form-container" method="post" action="/client/search">
								<input type="text" class="search-field" name="s" maxlength="50" value="" placeholder="<?php echo $CFG->search_box_placeholder; ?>"/>
								<div class="submit-container">
									<input type="submit" value="" class="submit" />

								</div>
							</form>
							<div>
								<?php
									$hlinks = $bclient->get_history_links();
									$hlinks = str_replace($CFG->site_url, '', $hlinks);
									//debug_to_console($hlinks);
									echo $hlinks;
								?>
							</div>
						</div>
					</div>
				</div>
			</div>
		</header>
		<div class="main">
<!--==============================Content=================================-->
			<div class="content">
				<?php
					if($request_type === 'search') {
						include 'includes/sresults.php';
					}
					else if($request_type === 'page') {
						include 'includes/content.php';
					}
					else {
						//echo "redirecting to home";
						include 'includes/home.php';
					}
				?>
			</div>
<!--==============================footer=================================-->
			<?php include "footer.php"; ?>
		</div>
     </body>
</html>

<?php
$content = minify_html( ob_get_clean() );

echo $content;
?>